/*******************************************************************************
* File Name: My_CapSense_1_SampleClk.h
* Version 2.20
*
*  Description:
*   Provides the function and constant definitions for the clock component.
*
*  Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_CLOCK_My_CapSense_1_SampleClk_H)
#define CY_CLOCK_My_CapSense_1_SampleClk_H

#include <cytypes.h>
#include <cyfitter.h>


/***************************************
*        Function Prototypes
***************************************/
#if defined CYREG_PERI_DIV_CMD

void My_CapSense_1_SampleClk_StartEx(uint32 alignClkDiv);
#define My_CapSense_1_SampleClk_Start() \
    My_CapSense_1_SampleClk_StartEx(My_CapSense_1_SampleClk__PA_DIV_ID)

#else

void My_CapSense_1_SampleClk_Start(void);

#endif/* CYREG_PERI_DIV_CMD */

void My_CapSense_1_SampleClk_Stop(void);

void My_CapSense_1_SampleClk_SetFractionalDividerRegister(uint16 clkDivider, uint8 clkFractional);

uint16 My_CapSense_1_SampleClk_GetDividerRegister(void);
uint8  My_CapSense_1_SampleClk_GetFractionalDividerRegister(void);

#define My_CapSense_1_SampleClk_Enable()                         My_CapSense_1_SampleClk_Start()
#define My_CapSense_1_SampleClk_Disable()                        My_CapSense_1_SampleClk_Stop()
#define My_CapSense_1_SampleClk_SetDividerRegister(clkDivider, reset)  \
    My_CapSense_1_SampleClk_SetFractionalDividerRegister((clkDivider), 0u)
#define My_CapSense_1_SampleClk_SetDivider(clkDivider)           My_CapSense_1_SampleClk_SetDividerRegister((clkDivider), 1u)
#define My_CapSense_1_SampleClk_SetDividerValue(clkDivider)      My_CapSense_1_SampleClk_SetDividerRegister((clkDivider) - 1u, 1u)


/***************************************
*             Registers
***************************************/
#if defined CYREG_PERI_DIV_CMD

#define My_CapSense_1_SampleClk_DIV_ID     My_CapSense_1_SampleClk__DIV_ID

#define My_CapSense_1_SampleClk_CMD_REG    (*(reg32 *)CYREG_PERI_DIV_CMD)
#define My_CapSense_1_SampleClk_CTRL_REG   (*(reg32 *)My_CapSense_1_SampleClk__CTRL_REGISTER)
#define My_CapSense_1_SampleClk_DIV_REG    (*(reg32 *)My_CapSense_1_SampleClk__DIV_REGISTER)

#define My_CapSense_1_SampleClk_CMD_DIV_SHIFT          (0u)
#define My_CapSense_1_SampleClk_CMD_PA_DIV_SHIFT       (8u)
#define My_CapSense_1_SampleClk_CMD_DISABLE_SHIFT      (30u)
#define My_CapSense_1_SampleClk_CMD_ENABLE_SHIFT       (31u)

#define My_CapSense_1_SampleClk_CMD_DISABLE_MASK       ((uint32)((uint32)1u << My_CapSense_1_SampleClk_CMD_DISABLE_SHIFT))
#define My_CapSense_1_SampleClk_CMD_ENABLE_MASK        ((uint32)((uint32)1u << My_CapSense_1_SampleClk_CMD_ENABLE_SHIFT))

#define My_CapSense_1_SampleClk_DIV_FRAC_MASK  (0x000000F8u)
#define My_CapSense_1_SampleClk_DIV_FRAC_SHIFT (3u)
#define My_CapSense_1_SampleClk_DIV_INT_MASK   (0xFFFFFF00u)
#define My_CapSense_1_SampleClk_DIV_INT_SHIFT  (8u)

#else 

#define My_CapSense_1_SampleClk_DIV_REG        (*(reg32 *)My_CapSense_1_SampleClk__REGISTER)
#define My_CapSense_1_SampleClk_ENABLE_REG     My_CapSense_1_SampleClk_DIV_REG
#define My_CapSense_1_SampleClk_DIV_FRAC_MASK  My_CapSense_1_SampleClk__FRAC_MASK
#define My_CapSense_1_SampleClk_DIV_FRAC_SHIFT (16u)
#define My_CapSense_1_SampleClk_DIV_INT_MASK   My_CapSense_1_SampleClk__DIVIDER_MASK
#define My_CapSense_1_SampleClk_DIV_INT_SHIFT  (0u)

#endif/* CYREG_PERI_DIV_CMD */

#endif /* !defined(CY_CLOCK_My_CapSense_1_SampleClk_H) */

/* [] END OF FILE */
