/*******************************************************************************
* File Name: My_CapSense_1_SenseClk.h
* Version 2.20
*
*  Description:
*   Provides the function and constant definitions for the clock component.
*
*  Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_CLOCK_My_CapSense_1_SenseClk_H)
#define CY_CLOCK_My_CapSense_1_SenseClk_H

#include <cytypes.h>
#include <cyfitter.h>


/***************************************
*        Function Prototypes
***************************************/
#if defined CYREG_PERI_DIV_CMD

void My_CapSense_1_SenseClk_StartEx(uint32 alignClkDiv);
#define My_CapSense_1_SenseClk_Start() \
    My_CapSense_1_SenseClk_StartEx(My_CapSense_1_SenseClk__PA_DIV_ID)

#else

void My_CapSense_1_SenseClk_Start(void);

#endif/* CYREG_PERI_DIV_CMD */

void My_CapSense_1_SenseClk_Stop(void);

void My_CapSense_1_SenseClk_SetFractionalDividerRegister(uint16 clkDivider, uint8 clkFractional);

uint16 My_CapSense_1_SenseClk_GetDividerRegister(void);
uint8  My_CapSense_1_SenseClk_GetFractionalDividerRegister(void);

#define My_CapSense_1_SenseClk_Enable()                         My_CapSense_1_SenseClk_Start()
#define My_CapSense_1_SenseClk_Disable()                        My_CapSense_1_SenseClk_Stop()
#define My_CapSense_1_SenseClk_SetDividerRegister(clkDivider, reset)  \
    My_CapSense_1_SenseClk_SetFractionalDividerRegister((clkDivider), 0u)
#define My_CapSense_1_SenseClk_SetDivider(clkDivider)           My_CapSense_1_SenseClk_SetDividerRegister((clkDivider), 1u)
#define My_CapSense_1_SenseClk_SetDividerValue(clkDivider)      My_CapSense_1_SenseClk_SetDividerRegister((clkDivider) - 1u, 1u)


/***************************************
*             Registers
***************************************/
#if defined CYREG_PERI_DIV_CMD

#define My_CapSense_1_SenseClk_DIV_ID     My_CapSense_1_SenseClk__DIV_ID

#define My_CapSense_1_SenseClk_CMD_REG    (*(reg32 *)CYREG_PERI_DIV_CMD)
#define My_CapSense_1_SenseClk_CTRL_REG   (*(reg32 *)My_CapSense_1_SenseClk__CTRL_REGISTER)
#define My_CapSense_1_SenseClk_DIV_REG    (*(reg32 *)My_CapSense_1_SenseClk__DIV_REGISTER)

#define My_CapSense_1_SenseClk_CMD_DIV_SHIFT          (0u)
#define My_CapSense_1_SenseClk_CMD_PA_DIV_SHIFT       (8u)
#define My_CapSense_1_SenseClk_CMD_DISABLE_SHIFT      (30u)
#define My_CapSense_1_SenseClk_CMD_ENABLE_SHIFT       (31u)

#define My_CapSense_1_SenseClk_CMD_DISABLE_MASK       ((uint32)((uint32)1u << My_CapSense_1_SenseClk_CMD_DISABLE_SHIFT))
#define My_CapSense_1_SenseClk_CMD_ENABLE_MASK        ((uint32)((uint32)1u << My_CapSense_1_SenseClk_CMD_ENABLE_SHIFT))

#define My_CapSense_1_SenseClk_DIV_FRAC_MASK  (0x000000F8u)
#define My_CapSense_1_SenseClk_DIV_FRAC_SHIFT (3u)
#define My_CapSense_1_SenseClk_DIV_INT_MASK   (0xFFFFFF00u)
#define My_CapSense_1_SenseClk_DIV_INT_SHIFT  (8u)

#else 

#define My_CapSense_1_SenseClk_DIV_REG        (*(reg32 *)My_CapSense_1_SenseClk__REGISTER)
#define My_CapSense_1_SenseClk_ENABLE_REG     My_CapSense_1_SenseClk_DIV_REG
#define My_CapSense_1_SenseClk_DIV_FRAC_MASK  My_CapSense_1_SenseClk__FRAC_MASK
#define My_CapSense_1_SenseClk_DIV_FRAC_SHIFT (16u)
#define My_CapSense_1_SenseClk_DIV_INT_MASK   My_CapSense_1_SenseClk__DIVIDER_MASK
#define My_CapSense_1_SenseClk_DIV_INT_SHIFT  (0u)

#endif/* CYREG_PERI_DIV_CMD */

#endif /* !defined(CY_CLOCK_My_CapSense_1_SenseClk_H) */

/* [] END OF FILE */
