/*******************************************************************************
* File Name: SBS_LED_GRN.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_SBS_LED_GRN_H) /* Pins SBS_LED_GRN_H */
#define CY_PINS_SBS_LED_GRN_H

#include "cytypes.h"
#include "cyfitter.h"
#include "SBS_LED_GRN_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    SBS_LED_GRN_Write(uint8 value) ;
void    SBS_LED_GRN_SetDriveMode(uint8 mode) ;
uint8   SBS_LED_GRN_ReadDataReg(void) ;
uint8   SBS_LED_GRN_Read(void) ;
uint8   SBS_LED_GRN_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define SBS_LED_GRN_DRIVE_MODE_BITS        (3)
#define SBS_LED_GRN_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - SBS_LED_GRN_DRIVE_MODE_BITS))

#define SBS_LED_GRN_DM_ALG_HIZ         (0x00u)
#define SBS_LED_GRN_DM_DIG_HIZ         (0x01u)
#define SBS_LED_GRN_DM_RES_UP          (0x02u)
#define SBS_LED_GRN_DM_RES_DWN         (0x03u)
#define SBS_LED_GRN_DM_OD_LO           (0x04u)
#define SBS_LED_GRN_DM_OD_HI           (0x05u)
#define SBS_LED_GRN_DM_STRONG          (0x06u)
#define SBS_LED_GRN_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define SBS_LED_GRN_MASK               SBS_LED_GRN__MASK
#define SBS_LED_GRN_SHIFT              SBS_LED_GRN__SHIFT
#define SBS_LED_GRN_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define SBS_LED_GRN_PS                     (* (reg32 *) SBS_LED_GRN__PS)
/* Port Configuration */
#define SBS_LED_GRN_PC                     (* (reg32 *) SBS_LED_GRN__PC)
/* Data Register */
#define SBS_LED_GRN_DR                     (* (reg32 *) SBS_LED_GRN__DR)
/* Input Buffer Disable Override */
#define SBS_LED_GRN_INP_DIS                (* (reg32 *) SBS_LED_GRN__PC2)


#if defined(SBS_LED_GRN__INTSTAT)  /* Interrupt Registers */

    #define SBS_LED_GRN_INTSTAT                (* (reg32 *) SBS_LED_GRN__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define SBS_LED_GRN_DRIVE_MODE_SHIFT       (0x00u)
#define SBS_LED_GRN_DRIVE_MODE_MASK        (0x07u << SBS_LED_GRN_DRIVE_MODE_SHIFT)


#endif /* End Pins SBS_LED_GRN_H */


/* [] END OF FILE */
