/*******************************************************************************
* File Name: SBS_LED_RED.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_SBS_LED_RED_H) /* Pins SBS_LED_RED_H */
#define CY_PINS_SBS_LED_RED_H

#include "cytypes.h"
#include "cyfitter.h"
#include "SBS_LED_RED_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    SBS_LED_RED_Write(uint8 value) ;
void    SBS_LED_RED_SetDriveMode(uint8 mode) ;
uint8   SBS_LED_RED_ReadDataReg(void) ;
uint8   SBS_LED_RED_Read(void) ;
uint8   SBS_LED_RED_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define SBS_LED_RED_DRIVE_MODE_BITS        (3)
#define SBS_LED_RED_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - SBS_LED_RED_DRIVE_MODE_BITS))

#define SBS_LED_RED_DM_ALG_HIZ         (0x00u)
#define SBS_LED_RED_DM_DIG_HIZ         (0x01u)
#define SBS_LED_RED_DM_RES_UP          (0x02u)
#define SBS_LED_RED_DM_RES_DWN         (0x03u)
#define SBS_LED_RED_DM_OD_LO           (0x04u)
#define SBS_LED_RED_DM_OD_HI           (0x05u)
#define SBS_LED_RED_DM_STRONG          (0x06u)
#define SBS_LED_RED_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define SBS_LED_RED_MASK               SBS_LED_RED__MASK
#define SBS_LED_RED_SHIFT              SBS_LED_RED__SHIFT
#define SBS_LED_RED_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define SBS_LED_RED_PS                     (* (reg32 *) SBS_LED_RED__PS)
/* Port Configuration */
#define SBS_LED_RED_PC                     (* (reg32 *) SBS_LED_RED__PC)
/* Data Register */
#define SBS_LED_RED_DR                     (* (reg32 *) SBS_LED_RED__DR)
/* Input Buffer Disable Override */
#define SBS_LED_RED_INP_DIS                (* (reg32 *) SBS_LED_RED__PC2)


#if defined(SBS_LED_RED__INTSTAT)  /* Interrupt Registers */

    #define SBS_LED_RED_INTSTAT                (* (reg32 *) SBS_LED_RED__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define SBS_LED_RED_DRIVE_MODE_SHIFT       (0x00u)
#define SBS_LED_RED_DRIVE_MODE_MASK        (0x07u << SBS_LED_RED_DRIVE_MODE_SHIFT)


#endif /* End Pins SBS_LED_RED_H */


/* [] END OF FILE */
